/*
 * Copyright 2019 NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PERIPHERALS_H_
#define _PERIPHERALS_H_

/***********************************************************************************************************************
 * Included files
 **********************************************************************************************************************/
#include "fsl_common.h"
#include "fsl_clock.h"
#include "fsl_lpi2c.h"
#include "fsl_tpm.h"

#if defined(__cplusplus)
extern "C" {
#endif /* __cplusplus */

/***********************************************************************************************************************
 * Definitions
 **********************************************************************************************************************/
/* Definitions for BOARD_InitPeripherals functional group */
/* BOARD_InitPeripherals defines for LPI2C0 */
/* Definition of peripheral ID */
#define ACCEL_I2C_PERIPHERAL LPI2C0
/* Definition of clock source */
#define ACCEL_I2C_CLOCK_FREQ CLOCK_GetIpFreq(kCLOCK_Lpi2c0)
/* Transfer buffer size */
#define ACCEL_I2C_MASTER_BUFFER_SIZE 1
/* Definition of peripheral ID */
#define TIMER_PERIPHERAL TPM0
/* Definition of the clock source frequency */
#define TIMER_CLOCK_SOURCE 48000000UL
/* TIMER interrupt vector ID (number). */
#define TIMER_IRQN TPM0_IRQn
/* TIMER interrupt handler identifier. */
#define TIMER_IRQHANDLER TPM0_IRQHandler

/***********************************************************************************************************************
 * Global variables
 **********************************************************************************************************************/
extern const lpi2c_master_config_t ACCEL_I2C_masterConfig;
extern lpi2c_master_transfer_t ACCEL_I2C_masterTransfer;
extern uint8_t ACCEL_I2C_masterBuffer[ACCEL_I2C_MASTER_BUFFER_SIZE];
extern const tpm_config_t TIMER_config;

/***********************************************************************************************************************
 * Initialization functions
 **********************************************************************************************************************/
void BOARD_InitPeripherals(void);

/***********************************************************************************************************************
 * BOARD_InitBootPeripherals function
 **********************************************************************************************************************/
void BOARD_InitBootPeripherals(void);

#if defined(__cplusplus)
}
#endif

#endif /* _PERIPHERALS_H_ */
